package com.plannaplan.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import static org.junit.Assert.assertTrue;

import java.util.List;

import com.plannaplan.entities.Assignment;
import com.plannaplan.entities.Commision;

import org.junit.Before;
import org.junit.Test;

import org.junit.runner.RunWith;

@RunWith(SpringRunner.class)
@SpringBootTest
@ContextConfiguration
public class AssignmentServiceTest {

    @Autowired
    private AssignmentService service;
    @Autowired
    private CommisionService comServie;
    private Commision com;

    @Before
    public void init() {
        this.com = new Commision();
        this.comServie.save(this.com);
    }

    @Test
    public void shouldSaveAssignment() {
        long beginState = this.service.getAssignmentsAmmount();
        this.addAssignmentToCommision(this.com);
        assertTrue("Assign ammount should increase", this.service.getAssignmentsAmmount() > beginState);
    }

    @Test
    public void shouldGetCommisionAssignments() {
        this.addAssignmentToCommision(this.com);
        final List<Assignment> response = this.service.getCommisionAssignments(com);
        assertTrue("Returned list size should be 1", response.size() == 1);
    }

    private void addAssignmentToCommision(Commision com) {
        Assignment a = new Assignment(null, com);
        this.service.save(a);
    }

}
