package com.plannaplan.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import static org.junit.Assert.assertTrue;

import java.io.InputStream;

import com.plannaplan.TestApplication;
import com.plannaplan.models.ConfigData;

import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(SpringRunner.class)
@SpringBootTest
@ContextConfiguration
public class ConfiguratorServiceTest {

    @Autowired
    private ConfiguratorService configuratorService;

    @Autowired
    private CourseService courseService;

    @Autowired
    private GroupService groupService;

    @Autowired
    private LecturerService lecturerService;

    @Test
    public void shouldImportDataToDataBase() {
        final InputStream inputStream = getClass().getClassLoader()
                .getResourceAsStream(TestApplication.TEST_CONFIG_FILE);
        final ConfigData data = new ConfigData(null, null, inputStream);
        this.configuratorService.config(data);

        int courses_ammount = this.courseService.getCoursesAmmount();
        int groups_ammount = this.groupService.getGroupsAmmount();
        int lecturers_ammount = this.lecturerService.getLecturersAmmount();

        assertTrue(courses_ammount > 0 && groups_ammount > 0 && lecturers_ammount > 0);
    }

}
