package com.plannaplan.controllers;

import java.util.Optional;

import com.plannaplan.entities.User;
import com.plannaplan.exceptions.UserNotFoundException;
import com.plannaplan.services.UserService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.authentication.AnonymousAuthenticationToken;

public abstract class TokenBasedController {
    @Autowired
    protected UserService userService;

    public TokenBasedController() {
    }

    protected Optional<User> getCurrentUser() throws UserNotFoundException {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();

        if (!(authentication instanceof AnonymousAuthenticationToken)) {
            return Optional.of(this.userService.getUserByEmail(authentication.getName()));
        } else {
            return Optional.empty();
        }
    }
}