package com.plannaplan.responses.mappers;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

import com.plannaplan.entities.Groups;
import com.plannaplan.responses.models.DefaultGroupResponse;
import com.plannaplan.responses.models.GetCourseGroupsResponse;
import com.plannaplan.responses.models.WithCapacityGroupResponse;
import com.plannaplan.types.GroupType;

public class GroupsMappers {
    public static List<DefaultGroupResponse> mapToDefaultResponse(List<Groups> groups) {
        return groups.stream().filter(Objects::nonNull).map(DefaultGroupResponse::new).collect(Collectors.toList());
    }

    public static List<WithCapacityGroupResponse> mapToCapacityResponse(List<Groups> groups) {
        return groups.stream().filter(Objects::nonNull).map(WithCapacityGroupResponse::new)
                .collect(Collectors.toList());
    }
    
    public static GetCourseGroupsResponse<DefaultGroupResponse> mapToGetCourseGroupsDefaultResponse (List<Groups> groups){

        List<DefaultGroupResponse> lectures = new ArrayList<>();
        List<DefaultGroupResponse> classes = new ArrayList<>();

        groups.stream().forEach(group -> {
            if (group.getType() == GroupType.CLASS) {
                classes.add(new DefaultGroupResponse(group));
            } else {
                lectures.add(new DefaultGroupResponse(group));
            }
        });


        return new GetCourseGroupsResponse<>(classes, lectures);
    }

    public static GetCourseGroupsResponse<WithCapacityGroupResponse> mapToGetCourseGroupsWithCapacityResponse (List<Groups> groups){

        List<WithCapacityGroupResponse> lectures = new ArrayList<>();
        List<WithCapacityGroupResponse> classes = new ArrayList<>();

        groups.stream().forEach(group -> {
            if (group.getType() == GroupType.CLASS) {
                classes.add(new WithCapacityGroupResponse(group));
            } else {
                lectures.add(new WithCapacityGroupResponse(group));
            }
        });


        return new GetCourseGroupsResponse<>(classes, lectures);
    }

}
