package com.plannaplan.responses.models;

import java.util.ArrayList;
import java.util.List;

import com.plannaplan.entities.Course;
import com.plannaplan.responses.models.abstracts.CoursesResponse;
import com.plannaplan.types.GroupType;

public class GetCoursesWithGroupsResponse extends CoursesResponse {

    private List<DefaultGroupResponse> lectures = new ArrayList<>();
    private List<DefaultGroupResponse> classes = new ArrayList<>();

    public GetCoursesWithGroupsResponse(Course course) {
        super(course);
        course.getGroups().stream().forEach(group -> {
            if (group.getType() == GroupType.CLASS) {
                this.classes.add(new DefaultGroupResponse(group));
            } else {
                this.lectures.add(new DefaultGroupResponse(group));
            }
        });
    }

    public List<DefaultGroupResponse> getClasses() {
        return this.classes;
    }

    public List<DefaultGroupResponse> getLectures() {
        return this.lectures;
    }

}
