package com.plannaplan.responses.mappers;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.Arrays;
import java.util.List;

import com.plannaplan.entities.Assignment;
import com.plannaplan.entities.Commision;
import com.plannaplan.entities.Course;
import com.plannaplan.entities.Groups;
import com.plannaplan.responses.models.GetCurrentAssignmentsResponse;
import com.plannaplan.entities.Lecturer;
import com.plannaplan.types.WeekDay;

import org.junit.Test;

public class AssignmentResponseMappersTest {
    @Test
    public void shouldReturnNewList() {
        final Commision com = new Commision();
        final Course course = new Course("Kurs", "TES-T");
        final List<Assignment> groups = Arrays.asList(
                new Assignment(new Groups(142, "A4-1", course, 520, WeekDay.MONDAY,
                        new Lecturer("krul.", "Wladyslaw", "Potocki")), com),
                new Assignment(new Groups(32, "A4-1", course, 420, WeekDay.MONDAY,
                        new Lecturer("krul.", "Wladyslaw", "Potocki")), com));
        final List<GetCurrentAssignmentsResponse> response = AssignmentResponseMappers.mapToResponse(groups);

        assertTrue(response.size() == 1);
        assertTrue(response.get(0) instanceof GetCurrentAssignmentsResponse);
    }
}
