package com.plannaplan.responses.mappers;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.Arrays;
import java.util.List;

import com.plannaplan.entities.Course;
import com.plannaplan.responses.models.GetCoursesResponse;
import com.plannaplan.responses.models.GetCoursesWithGroupsResponse;

import org.junit.Test;

public class CoursesResponseMappersTest {
    @Test
    public void shouldMapListCoursesToResponseList() {
        final List<Course> courses = Arrays.asList(new Course(), new Course());
        final List<GetCoursesResponse> response = CoursesResponseMappers.mapToGetCoursesResponse(courses);

        assertTrue(response.size() == 2);
        assertTrue(response.get(0) instanceof GetCoursesResponse);

    }

    @Test
    public void shouldMapListCoursesToResponseWithGroupsList() {
        final List<Course> courses = Arrays.asList(new Course(), new Course());
        final List<GetCoursesWithGroupsResponse> response = CoursesResponseMappers
                .mapToGetCoursesWithGroupsResponse(courses);

        assertTrue(response.size() == 2);
        assertTrue(response.get(0) instanceof GetCoursesWithGroupsResponse);

    }
}
