package com.plannaplan.responses.models;

import static org.junit.jupiter.api.Assertions.assertTrue;

import com.plannaplan.entities.Course;
import com.plannaplan.entities.Groups;
import com.plannaplan.entities.Lecturer;
import com.plannaplan.types.WeekDay;

import org.junit.Test;

public class GetCurrentAssignmentsResponseTest {

    @Test
    public void shouldMapGroupsToResponse() {
        final Course course = new Course("Kurs", "tst.");
        final Groups lecture = new Groups(142, "A4-1", null, 520, WeekDay.MONDAY,
                new Lecturer("krul.", "Wladyslaw", "Potocki"));
        final Groups classes = new Groups(22, "A4-2", null, 580, WeekDay.MONDAY,
                new Lecturer("krul.", "Wladyslaw", "Potocki"));

        final GetCurrentAssignmentsResponse response = new GetCurrentAssignmentsResponse(course, lecture, classes);
        assertTrue(response.getName() == "Kurs");
        assertTrue(response.getLecture() instanceof WithCapacityGroupResponse);
        assertTrue(response.getClasses() instanceof WithCapacityGroupResponse);
    }

    @Test
    public void shouldMapLectureToResponse() {
        final Course course = new Course("Kurs", "tst.");
        final Groups lecture = new Groups(142, "A4-1", null, 520, WeekDay.MONDAY,
                new Lecturer("krul.", "Wladyslaw", "Potocki"));

        final GetCurrentAssignmentsResponse response = new GetCurrentAssignmentsResponse(course, lecture);
        assertTrue(response.getName() == "Kurs");
        assertTrue(response.getLecture() instanceof WithCapacityGroupResponse);
        assertTrue(response.getClasses() == null);
    }

    @Test
    public void shouldMapClassToResponse() {
        final Course course = new Course("Kurs", "tst.");
        final Groups classes = new Groups(22, "A4-2", null, 580, WeekDay.MONDAY,
                new Lecturer("krul.", "Wladyslaw", "Potocki"));

        final GetCurrentAssignmentsResponse response = new GetCurrentAssignmentsResponse(course, classes);
        assertTrue(response.getName() == "Kurs");
        assertTrue(response.getLecture() == null);
        assertTrue(response.getClasses() instanceof WithCapacityGroupResponse);
    }

}
